<?php

namespace App\Http\Requests;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class ProductRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin', 'sub_admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule( 'products' ) )
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
            'images' => 'required|array|min:1',
//            'code' => 'required|array',
            'product_id' => 'sometimes',
//            'image' => 'sometimes',
        ];

        foreach (languages() as $lang) {
            $lang_rules=[
                'name_'.$lang->local=> 'required|min:3',
                'keywords_'.$lang->local=> 'required|min:3',
                'meta_description_'.$lang->local=> 'required|min:3',
                'description_'.$lang->local=> 'required|min:3',
            ];
            $rules= array_merge($rules, $lang_rules);
        }

        if (request()->has('code')){
            foreach (request('code') as $key => $code) {
                if ($code == null){
                    $rules['all_code'] = 'required';
                }
            }
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $field = metaFields('products');
        $local = getCurrentLocale();
        $attributes=[
            'images' => $field[$local]['images'] ?? __('products.images'),
            'code' => $field[$local]['code'] ?? __('products.code'),
            'product_id' => $field[$local]['product_id'] ?? __('products.product_id'),
        ];
        foreach (languages() as $lang) {
            $lang_attributes=[
                'name_'.$lang->local=> $field[$lang->local]['name'] ?? __('products.name'),
                'slug_'.$lang->local=>  $field[$lang->local]['slug'] ?? __('products.slug'),
                'keywords_'.$lang->local=> $field[$lang->local]['keywords'] ?? __('products.keywords'),
                'meta_description_'.$lang->local=> $field[$lang->local]['meta_description'] ?? __('products.meta_description'),
                'description_'.$lang->local=> $field[$lang->local]['description'] ?? __('products.description'),
            ];
            $attributes= array_merge($attributes, $lang_attributes);
        }

        return $attributes;
    }
    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests
        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
